import unittest
from solution import *
# from objects_ex import *

class TestEx1(unittest.TestCase):
    """ tests car class"""

    def test_init(self):
        c = Car("Mazda CX-5", 180)
        self.assertEqual(c.type, "Mazda CX-5")
        self.assertEqual(c.hp, 180)

    def test_kw_constructor(self):
        c = Car.car_kw("Mazda CX-5", 132)
        self.assertEqual(c.hp, 180)

    def test_string(self):
        c = Car.car_kw("Mazda CX-5", 132)
        self.assertEqual(str(c), "Mazda CX-5: 180 hp")


class TestEx2(unittest.TestCase):
    """ test ABC """
    def test_base_is_abstract(self):
        with self.assertRaises(TypeError):
            a = Input()
    
    def test_instance_fileinput(self):
        f = FileInput()
        self.assertIsInstance(f, Input)

    def test_instance_listinput(self):
        l = ListInput()
        self.assertIsInstance(l, Input)
    
    def test_content_file(self):
        testfile = io.StringIO("1\n2\n")
        f = FileInput()
        f.read(testfile)
        c = list(f.content())
        self.assertEqual(c, ["1\n", "2\n"])

    def test_content_list(self):
        f = ListInput()
        f.read([1, 2, 3])
        c = list(f.content())
        self.assertEqual(c, [1, 2, 3])


if __name__ == '__main__':
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestEx1))

    # TODO uncomment the following test if you proceed

    # tests for exercise 2
    suite.addTest(unittest.makeSuite(TestEx2))

    unittest.TextTestRunner(verbosity=3).run(suite)


